Index: java/main/src/main/java/com/framsticks/params/Util.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Util.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/Util.java	(revision 100)
@@ -24,7 +24,7 @@
 	}
 
-	public static <T> List<T> stripAccessInterface(List<AccessInterface> accesses, Class<T> type) {
+	public static <T> List<T> stripAccess(List<Access> accesses, Class<T> type) {
 		List<T> result = new ArrayList<T>();
-		for (AccessInterface a : accesses) {
+		for (Access a : accesses) {
 			Object object = a.getSelected();
 			if (!type.isInstance(object)) {
@@ -36,5 +36,5 @@
 	}
 
-	public static int takeAllNonNullValues(AccessInterface to, AccessInterface from) {
+	public static int takeAllNonNullValues(Access to, Access from) {
 		int copied = 0;
 		for (ValueParam f : filterInstanceof(from.getParams(), ValueParam.class)) {
@@ -43,4 +43,7 @@
 				continue;
 			}
+			// if (to.get(f, Object.class) != null) {
+			//	continue;
+			// }
 			to.set(f, v);
 			++copied;
@@ -49,5 +52,5 @@
 	}
 
-	public static int copyExistingParamsTypeSafe(AccessInterface to, AccessInterface from) {
+	public static int copyExistingParamsTypeSafe(Access to, Access from) {
 		int copied = 0;
 		for (ValueParam f : filterInstanceof(from.getParams(), ValueParam.class)) {
@@ -65,3 +68,23 @@
 	}
 
+	public static <T> T selectObjectForAccess(Access access, Object object, Class<T> type) {
+		if (object == null) {
+			return null;
+		}
+		if (!type.isInstance(object)) {
+			throw new FramsticksException().msg("trying to select object of wrong type").arg("object", object).arg("type", object.getClass()).arg("in", access);
+		}
+		return type.cast(object);
+	}
+
+	public static int getNumberOfCompositeParamChild(Access access, Object child) {
+		int count = access.getCompositeParamCount();
+		for (int i = 0; i < count; ++i) {
+			if (access.get(i, Object.class) == child) {
+				return i;
+			}
+		}
+		return -1;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java	(revision 100)
@@ -1,5 +1,5 @@
 package com.framsticks.params.types;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.ArrayListAccess;
 import com.framsticks.params.CastFailure;
@@ -7,8 +7,6 @@
 import com.framsticks.params.ReassignResult;
 import com.framsticks.util.lang.Casting;
-import com.framsticks.util.lang.Containers;
 import com.framsticks.util.lang.Numbers;
 
-import java.util.ArrayList;
 import java.util.List;
 
@@ -32,5 +30,5 @@
 
 	@Override
-	public AccessInterface prepareAccessInterface(AccessInterface access) {
+	public Access prepareAccess(Access access) {
 		return new ArrayListAccess(access);
 	}
@@ -49,19 +47,20 @@
 		if (size != null) {
 			//return oldValue;
-			List<?> list;
-			if (oldValue == null) {
-				list = new ArrayList<Object>();
-			} else {
-				list = Casting.tryCast(List.class, oldValue);
-				if (list == null) {
-					throw new CastFailure();
-				}
-			}
-			Containers.resizeList(list, size);
-			return new ReassignResult<List<?>>(list);
+			// List<?> list;
+			// if (oldValue == null) {
+			// 	list = new ArrayList<Object>();
+			// } else {
+			// 	list = Casting.tryCast(List.class, oldValue);
+			// 	if (list == null) {
+			// 		throw new CastFailure();
+			// 	}
+			// }
+			// Containers.resizeList(list, size);
+			return new ReassignResult<List<?>>(Casting.tryCast(List.class, oldValue));
+			// return new ReassignResult<List<?>>(list);
 		}
-		if (oldValue != null) {
-			return new ReassignResult<List<?>>(Casting.throwCast(List.class, oldValue));
-		}
+		// if (oldValue != null) {
+		// 	return new ReassignResult<List<?>>(Casting.throwCast(List.class, oldValue));
+		// }
 		return new ReassignResult<List<?>>(Casting.throwCast(List.class, newValue));
 	}
Index: java/main/src/main/java/com/framsticks/params/types/ObjectParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 100)
@@ -1,5 +1,5 @@
 package com.framsticks.params.types;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.CastFailure;
 import com.framsticks.params.CompositeParam;
@@ -41,5 +41,5 @@
 
 	@Override
-	public AccessInterface prepareAccessInterface(AccessInterface access) {
+	public Access prepareAccess(Access access) {
 		return access;
 	}
Index: java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java	(revision 100)
@@ -1,5 +1,5 @@
 package com.framsticks.params.types;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.CastFailure;
 import com.framsticks.params.ParamBuilder;
@@ -38,5 +38,5 @@
 
 	@Override
-	public AccessInterface prepareAccessInterface(AccessInterface access) {
+	public Access prepareAccess(Access access) {
 		return new UniqueListAccess(access, uidName);
 	}
Index: java/main/src/main/java/com/framsticks/parsers/AutoInjector.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/AutoInjector.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/parsers/AutoInjector.java	(revision 100)
@@ -0,0 +1,26 @@
+package com.framsticks.parsers;
+
+import java.util.Collections;
+import java.util.LinkedList;
+import java.util.List;
+
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.AutoBuilder;
+
+@FramsClassAnnotation
+public class AutoInjector implements AutoBuilder {
+
+	protected final List<Object> objects = new LinkedList<>();
+
+	@Override
+	public List<Object> autoFinish() {
+		return Collections.unmodifiableList(objects);
+	}
+
+	@AutoAppendAnnotation
+	public void append(Object object) {
+		objects.add(object);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 100)
@@ -21,8 +21,9 @@
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.lang.Strings;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import static com.framsticks.params.ParamFlags.*;
 import static com.framsticks.params.SetStateFlags.*;
@@ -33,10 +34,10 @@
 public class F0Parser {
 
-	private final static Logger log = Logger.getLogger(F0Parser.class);
+	private final static Logger log = LogManager.getLogger(F0Parser.class);
 
 	/** The schema proper for f0 representation. */
 	protected final Schema schema;
 	protected final InputStream is;
-	protected final List<AccessInterface> result = new ArrayList<AccessInterface>();
+	protected final List<Access> result = new ArrayList<Access>();
 	int lineNumber = 0;
 
@@ -48,5 +49,5 @@
 	}
 
-	protected AccessInterface processLine(String line) {
+	protected Access processLine(String line) {
 		try {
 
@@ -57,5 +58,5 @@
 				throw new Exception("unknown class id: " + classId);
 			}
-			AccessInterface access = schema.getRegistry().createAccess(classId, framsClass);
+			Access access = schema.getRegistry().createAccess(classId, framsClass);
 			access.select(access.createAccessee());
 			for (Exception e : loadFromLine(access, p.second)) {
@@ -84,5 +85,5 @@
 	 *             the parse exception
 	 */
-	public List<AccessInterface> parse() {
+	public List<Access> parse() {
 
 		try (InputStreamReader reader = new InputStreamReader(is, Encoding.getDefaultCharset())) {
@@ -105,5 +106,5 @@
 					continue;
 				}
-				AccessInterface access = processLine(line);
+				Access access = processLine(line);
 				if (access != null) {
 					result.add(access);
@@ -123,5 +124,5 @@
 
 	private static void warn(int lineNumber, String message, Exception e) {
-		log.warn("in line " + lineNumber + " the following error occurred (" + message + "): " + e);
+		log.warn("in line {} the following error occurred ({}): {}", lineNumber, message, e);
 	}
 
@@ -170,5 +171,5 @@
 	}
 
-	public List<Exception> loadFromLine(AccessInterface access, String parameters) throws Exception {
+	public List<Exception> loadFromLine(Access access, String parameters) throws Exception {
 
 		List<Entry> entries = breakIntoEntries(parameters);
@@ -250,5 +251,5 @@
 	}
 
-	private static Exception createBoundaryHitException(AccessInterface access, PrimitiveParam<?> param, String value, int flag) {
+	private static Exception createBoundaryHitException(Access access, PrimitiveParam<?> param, String value, int flag) {
 		boolean minimum = (flag & PSET_HITMIN) != 0;
 		String boundary = (minimum ? param.getMin(Object.class) : param.getMax(Object.class)).toString();
Index: java/main/src/main/java/com/framsticks/parsers/F0Writer.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 100)
@@ -30,5 +30,5 @@
 	}
 
-	protected void write(AccessInterface access) {
+	protected void write(Access access) {
 		if (access instanceof ListAccess) {
 			// TODO
@@ -45,5 +45,5 @@
 		for (ValueParam param : filterInstanceof(access.getParams(), ValueParam.class)) {
 			if (param instanceof CompositeParam) {
-				AccessInterface a = schema.getRegistry().prepareAccess((CompositeParam) param);
+				Access a = schema.getRegistry().prepareAccess((CompositeParam) param);
 				a.select(access.get((ValueParam) param, Object.class));
 				write(a);
@@ -81,5 +81,5 @@
 
 	public void write() {
-		AccessInterface access = schema.getRegistry().createAccess("m");
+		Access access = schema.getRegistry().createAccess("m");
 		access.select(model);
 		write(access);
Index: java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java	(revision 100)
@@ -5,10 +5,11 @@
 import com.framsticks.params.types.*;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 import static com.framsticks.params.ParamFlags.*;
 
 public class GenotypeLoader extends MultiParamLoader {
 	private Genotype genotypeReturnObject = new Genotype();
-	private static Logger logger = Logger.getLogger(GenotypeLoader.class);
+	private static Logger logger = LogManager.getLogger(GenotypeLoader.class);
 
 	public GenotypeLoader() throws Exception {
@@ -54,6 +55,6 @@
 			.finish();
 
-		AccessInterface reflectionParam = new PropertiesAccess(entries);
-		addAccessInterface(reflectionParam);
+		Access reflectionParam = new PropertiesAccess(entries);
+		addAccess(reflectionParam);
 		addBreakCondition(Status.AfterObject);
 	}
Index: java/main/src/main/java/com/framsticks/parsers/Loaders.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 100)
@@ -4,5 +4,5 @@
 
 import com.framsticks.params.*;
-// import org.apache.log4j.Logger;
+// import org.apache.logging.log4j.Logger;
 
 /**
@@ -11,5 +11,5 @@
 public class Loaders {
 
-	// private static final Logger log = Logger.getLogger(Loaders.class.getName());
+	// private static final Logger log = LogManager.getLogger(Loaders.class.getName());
 
 	public static @Nonnull FramsClass loadFramsClass(SourceInterface source) throws ConstructionException {
@@ -19,9 +19,9 @@
 		final FramsClassBuilder builder = FramsClass.build();
 
-		final AccessInterface framsClassAccess = new ReflectionAccess(FramsClassBuilder.class, FramsClass.build().forClass(FramsClassBuilder.class));
-		AccessInterface paramBuilderAccess = new ReflectionAccess(ParamBuilder.class, FramsClass.build().forClass(ParamBuilder.class));
+		final Access framsClassAccess = new ReflectionAccess(FramsClassBuilder.class, FramsClass.build().forClass(FramsClassBuilder.class));
+		Access paramBuilderAccess = new ReflectionAccess(ParamBuilder.class, FramsClass.build().forClass(ParamBuilder.class));
 		framsClassAccess.select(builder);
-		loader.addAccessInterface(framsClassAccess);
-		loader.addAccessInterface(paramBuilderAccess);
+		loader.addAccess(framsClassAccess);
+		loader.addAccess(paramBuilderAccess);
 
 		loader.addListener(MultiParamLoader.Status.AfterObject, new MultiParamLoader.StatusListener() {
Index: java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 100)
@@ -2,5 +2,6 @@
 
 import com.framsticks.params.*;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.util.*;
@@ -12,5 +13,5 @@
 	}
 
-	private final static Logger log = Logger.getLogger(MultiParamLoader.class);
+	private final static Logger log = LogManager.getLogger(MultiParamLoader.class);
 
 	/**
@@ -18,6 +19,6 @@
 	 * should be passed.
 	 */
-	public AccessInterface getLastAccessInterface() {
-		return lastAccessInterface;
+	public Access getLastAccess() {
+		return lastAccess;
 	}
 
@@ -39,5 +40,5 @@
 	}
 
-	protected AccessInterface lastAccessInterface;
+	protected Access lastAccess;
 
 	protected static final FramsClass emptyFramsClass = FramsClass.build().idAndName("<empty>").finish();
@@ -46,5 +47,5 @@
 	 * objects in the file.
 	 */
-	protected AccessInterface emptyParam = new PropertiesAccess(emptyFramsClass);
+	protected Access emptyParam = new PropertiesAccess(emptyFramsClass);
 
 	/**
@@ -87,5 +88,5 @@
 	 * List of known classes.
 	 */
-	private Map<String, AccessInterface> knownParamInterfaces = new HashMap<String, AccessInterface>();
+	private Map<String, Access> knownParamInterfaces = new HashMap<String, Access>();
 
 	/**
@@ -132,5 +133,5 @@
 				}
 			}
-			log.trace("read line: " + currentLine);
+			log.trace("read line: {}", currentLine);
 
 			// empty line
@@ -158,5 +159,5 @@
 			}
 
-			// log.warn("unknown line: " + currentLine);
+			// log.warn("unknown line: {}", currentLine);
 			changeStatus(Status.OnError);
 			if (action == LoopAction.Break) {
@@ -177,12 +178,11 @@
 	 */
 	private LoopAction tryReadObject() {
-		if (status == Status.BeforeObject
-				|| (status == Status.BeforeUnknown && lastAccessInterface != null)) {
+		if (status == Status.BeforeObject || (status == Status.BeforeUnknown && lastAccess != null)) {
 			// found object - let it load data
-			if (lastAccessInterface.getSelected() == null) {
-				lastAccessInterface.select(lastAccessInterface.createAccessee());
-			}
-			log.trace("loading into " + lastAccessInterface);
-			lastAccessInterface.load(currentSource);
+			if (lastAccess.getSelected() == null) {
+				lastAccess.select(lastAccess.createAccessee());
+			}
+			log.trace("loading into {}", lastAccess);
+			lastAccess.load(currentSource);
 
 			if (changeStatus(Status.AfterObject)) {
@@ -191,5 +191,5 @@
 			return LoopAction.Continue;
 		} else if (status == Status.BeforeUnknown) {
-			log.warn("omitting unknown object: " + lastUnknownObjectName);
+			log.warn("omitting unknown object: {}", lastUnknownObjectName);
 
 			// found unknown object
@@ -262,7 +262,7 @@
 		if (line.charAt(line.length() - 1) == ':') {
 			String typeName = line.substring(0, line.length() - 1);
-			lastAccessInterface = knownParamInterfaces.get(typeName);
-
-			if (lastAccessInterface != null) {
+			lastAccess = knownParamInterfaces.get(typeName);
+
+			if (lastAccess != null) {
 				if (changeStatus(Status.BeforeObject)) {
 					return LoopAction.Break;
@@ -299,7 +299,7 @@
 	 * Adds another class.
 	 */
-	public void addAccessInterface(AccessInterface accessInterface) {
+	public void addAccess(Access access) {
 		/**TODO: by id or by name? rather by id, because from file is always lowercase*/
-		knownParamInterfaces.put(accessInterface.getId(), accessInterface);
+		knownParamInterfaces.put(access.getId(), access);
 	}
 
@@ -325,5 +325,5 @@
 
 	public boolean setNewSource(SourceInterface source) {
-		log.debug("switching current source to " + source.getFilename() + "...");
+		log.debug("switching current source to {}...", source.getFilename());
 
 		currentSource = source;
@@ -345,10 +345,9 @@
 		// check if it is already included and break if it is
 		if (isAlreadyIncluded(includeFilename)) {
-			log.debug("circular reference ignored (" + includeFilename
-					+ ")");
+			log.debug("circular reference ignored ({})", includeFilename);
 			return;
 		}
 
-		log.info("including file " + includeFilename + "...");
+		log.info("including file {}...", includeFilename);
 
 		SourceInterface newSource = currentSource.openInclude(includeFilename);
@@ -369,5 +368,5 @@
 		for (String file : fileStack) {
 			if (filename.equals(file)) {
-				log.warn("file " + filename + " was already included");
+				log.warn("file {} was already included", filename);
 				return true;
 			}
@@ -400,5 +399,5 @@
 	 */
 	private boolean changeStatus(Status status) {
-		log.trace("changing status: " + this.status.toString() + " -> " + status.toString());
+		log.trace("changing status: {} -> {}", this.status.toString(), status.toString());
 		this.status = status;
 		if (listeners.containsKey(status)) {
@@ -411,10 +410,10 @@
 
 	public Object returnObject() {
-		assert lastAccessInterface != null;
-		Object result = lastAccessInterface.getSelected();
+		assert lastAccess != null;
+		Object result = lastAccess.getSelected();
 		if (result == null) {
 			return null;
 		}
-		lastAccessInterface.select(null);
+		lastAccess.select(null);
 		return result;
 	}
@@ -426,3 +425,19 @@
 		listeners.get(status).add(listener);
 	}
+
+	public static List<Object> loadAll(SourceInterface source, Access access) {
+		final List<Object> result = new LinkedList<>();
+
+		final MultiParamLoader loader = new MultiParamLoader();
+		loader.setNewSource(source);
+		loader.addAccess(access);
+		loader.addListener(MultiParamLoader.Status.AfterObject, new StatusListener() {
+			@Override
+			public void onStatusChange() {
+				result.add(loader.returnObject());
+			}
+		});
+		loader.go();
+		return result;
+	}
 }
Index: java/main/src/main/java/com/framsticks/parsers/Savers.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 100)
@@ -10,6 +10,6 @@
 	public static <S extends SinkInterface> S saveFramsClass(S sink, FramsClass framsClass) {
 
-		AccessInterface framsClassAccess = new ReflectionAccess(FramsClass.class);
-		AccessInterface paramAccess = new ReflectionAccess(Param.class);
+		Access framsClassAccess = new ReflectionAccess(FramsClass.class);
+		Access paramAccess = new ReflectionAccess(Param.class);
 		framsClassAccess.select(framsClass);
 		framsClassAccess.save(sink);
Index: java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 100)
@@ -1,4 +1,7 @@
 package com.framsticks.parsers;
 
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileNotFoundException;
 import java.io.InputStream;
 import java.util.LinkedList;
@@ -8,5 +11,6 @@
 import javax.xml.parsers.DocumentBuilderFactory;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 import org.w3c.dom.Document;
 import org.w3c.dom.Element;
@@ -15,5 +19,5 @@
 import org.w3c.dom.NodeList;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.Registry;
 import com.framsticks.util.AutoBuilder;
@@ -22,5 +26,5 @@
 
 public class XmlLoader {
-	private static final Logger log = Logger.getLogger(XmlLoader.class);
+	private static final Logger log = LogManager.getLogger(XmlLoader.class);
 
 	protected Registry registry = new Registry();
@@ -30,4 +34,5 @@
 	 */
 	public XmlLoader() {
+		registry.registerAndBuild(AutoInjector.class);
 	}
 
@@ -56,5 +61,5 @@
 	}
 
-	public Object processElement(Element element) {
+	public Object processElement(Element element, Class<?> enclosingClass) {
 		final String name = mangleName(element.getNodeName());
 		if (name.equals("import")) {
@@ -67,6 +72,31 @@
 			}
 		}
+		if (name.equals("include")) {
+			String fileName = element.getAttribute("file");
+			if (Strings.notEmpty(fileName)) {
+				try {
+					return load(new FileInputStream(new File(fileName)), enclosingClass);
+				} catch (FileNotFoundException e) {
+					throw new FramsticksException().msg("failed to include file").arg("file", fileName).cause(e);
+				}
+			}
+			String resourceName = element.getAttribute("resource");
+			if (Strings.notEmpty(resourceName)) {
+				Class<?> javaClass = enclosingClass;
+				String className = element.getAttribute("class");
+				if (Strings.notEmpty(className)) {
+					try {
+						javaClass = Class.forName(className);
+					} catch (ClassNotFoundException e) {
+						throw new FramsticksException().msg("failed to find class for resource loading").arg("class name", className).cause(e);
+					}
+				}
 
-		AccessInterface access = registry.createAccess(name);
+				return load(javaClass.getResourceAsStream(resourceName), enclosingClass);
+			}
+			throw new FramsticksException().msg("invalid <include/> node");
+		}
+
+		Access access = registry.createAccess(name);
 
 		Object object = access.createAccessee();
@@ -81,5 +111,5 @@
 
 		NodeList children = element.getChildNodes();
-		log.debug("found " + children.getLength() + " children in " + object);
+		log.debug("found {} children in {}", children.getLength(), object);
 		for (int i = 0; i < children.getLength(); ++i) {
 			Node childNode = children.item(i);
@@ -87,5 +117,5 @@
 				continue;
 			}
-			Object childObject = processElement((Element) childNode);
+			Object childObject = processElement((Element) childNode, object.getClass());
 			if (childObject == null) {
 				continue;
@@ -104,10 +134,10 @@
 			}
 		}
-		log.debug("loaded " + object);
+		log.debug("loaded {}", object);
 
 		return object;
 	}
 
-	public Object load(InputStream stream) {
+	protected Object load(InputStream stream, Class<?> enclosingClass) {
 		try {
 			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
@@ -119,5 +149,5 @@
 			assert element != null;
 
-			return processElement(element);
+			return processElement(element, enclosingClass);
 
 		} catch (Exception e) {
@@ -129,5 +159,5 @@
 		registry.registerAndBuild(type);
 
-		Object object = load(stream);
+		Object object = load(stream, type);
 		if (type.isAssignableFrom(object.getClass())) {
 			return type.cast(object);
Index: java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 100)
@@ -28,5 +28,5 @@
 	//		public void run() {
 	//			++counter;
-	//			log.debug("counter is now: " + counter);
+	//			log.debug("counter is now: {}", counter);
 	//			again();
 	//		}
Index: java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 100)
@@ -5,5 +5,5 @@
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
@@ -15,5 +15,6 @@
 import com.framsticks.util.Logging;
 import com.framsticks.util.Stopwatch;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 import com.framsticks.util.dispatching.RunAt;
@@ -24,5 +25,5 @@
 public class RecursiveFetcher {
 
-	private final static Logger log = Logger.getLogger(RecursiveFetcher.class.getName());
+	private final static Logger log = LogManager.getLogger(RecursiveFetcher.class.getName());
 
 	protected final Tree tree;
@@ -40,5 +41,5 @@
 	protected void finished() {
 		assert tree.isActive();
-		log.info("recursively fetched in " + stopwatch);
+		log.info("recursively fetched in {}", stopwatch);
 		future.pass(null);
 	}
@@ -47,7 +48,7 @@
 		assert tree.isActive();
 		if (path == null || !path.isResolved()) {
-			log.warn("path " + path + " is not resolved - skipping");
+			log.warn("path {} is not resolved - skipping", path);
 		} else {
-			AccessInterface access = bindAccess(path);
+			Access access = bindAccess(path);
 			FramsClass framsClass = access.getFramsClass();
 			assert framsClass != null;
@@ -86,5 +87,5 @@
 			@Override
 			public void handle(FramsticksException e) {
-				log.error("failed to fetch values for " + path + ": " + e);
+				log.error("failed to fetch values for {}: ", path, e);
 				process(null);
 			}
